<!DOCTYPE html>
<html lang="en">

<head>
  <title>Task 37.30</title>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>

  <!-- Import Datatable sau jquery -->
  <!-- Import them style bootstrap cho datatable -->
  <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
  <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
  <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>

  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.15.3/css/all.min.css">
  <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.3.0/css/all.min.css">
</head>

<body>

  <div class="container">
    <h2 style="text-align: center;">Quản trị User</h2>
    <button class='btn btn-success btn-user-add'><i class="fa-solid fa-plus"></i>&nbsp;Add New</button> <br><br>

    <table class="table table-bordered table-striped table-hover" id="users-table">

      <thead>
        <tr>
          <th>ID</th>
          <th>Firstname</th>
          <th>Lastname</th>
          <th>Country</th>
          <th>Subject</th>
          <th>Customer Type</th>
          <th>Register Status</th>
          <th>Action</th>
        </tr>
      </thead>
      <tbody>
      </tbody>
    </table>
  </div>
  <!---- modal Thêm mới-->
  <div id="add-new-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Thêm User</h5>
          <button type="button" class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
          <div class="row form-group">
            <div class="col-sm-4">
              <label>First Name</label>
            </div>
            <div class="col-sm-8">
              <input id="inp-firstname" class="form-control" placeholder="...">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label>Last Name</label>
            </div>
            <div class="col-sm-8">
              <input id="inp-lastname" class="form-control" placeholder="...">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label>Subject</label>
            </div>
            <div class="col-sm-8">
              <input id="inp-subject" class="form-control" placeholder="...">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label>Country</label>
            </div>
            <div class="col-sm-8">
              <select id="select-country" class="form-control">
                <option value="VN">Việt Nam</option>
                <option value="USA">USA</option>
                <option value="AUS">Australia</option>
                <option value="CAN">Canada</option>
              </select>
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label>CustomerType</label>
            </div>
            <div class="col-sm-8">
              <select id="select-customer-type" class="form-control">
                <option value="Standard">Standard</option>
                <option value="Gold">Gold</option>
                <option value="Premium">Premium</option>
              </select>
            </div>
          </div>
        </div>
        <div class="modal-footer">
          <div class="row">
            <div class="col-sm-6"><button type="button" id="btn-modal-insert" style="width:200px"
                class="btn btn-success">Insert</button></div>
            <div class="col-sm-6"><button type="button" id="btn-modal-cancel" style="width:200px"
                class="btn btn-success">Cancel</button></div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!--Modal Sửa-->
  <div id="update-modal" class="modal fade" tabindex="-1">
    <div class="modal-dialog">
      <div class="modal-content">
        <div class="modal-header">
          <h5 class="modal-title">Edit-Update User</h5>
          <button type="button" class="close" data-dismiss="modal">&times;</button>
        </div>
        <div class="modal-body">
          <div class="row form-group">
            <div class="col-sm-4">
              <label>First Name</label>
            </div>
            <div class="col-sm-8">
              <input id="edit-inp-firstname" class="form-control" placeholder="...">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label>Last Name</label>
            </div>
            <div class="col-sm-8">
              <input id="edit-inp-lastname" class="form-control" placeholder="...">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label>Subject</label>
            </div>
            <div class="col-sm-8">
              <input id="edit-inp-subject" class="form-control" placeholder="...">
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label>Country</label>
            </div>
            <div class="col-sm-8">
              <select id="edit-select-country" class="form-control">
                <option value="VN">Việt Nam</option>
                <option value="USA">USA</option>
                <option value="AUS">Australia</option>
                <option value="CAN">Canada</option>
              </select>
            </div>
          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label>CustomerType</label>
            </div>
            <div class="col-sm-8">
              <select id="edit-select-customer-type" class="form-control">
                <option value="Standard">Standard</option>
                <option value="Gold">Gold</option>
                <option value="Premium">Premium</option>
              </select>
            </div>

          </div>
          <div class="row form-group">
            <div class="col-sm-4">
              <label>Register Status</label>
            </div>
            <div class="col-sm-8">
              <select id="edit-select-registerStatus" class="form-control">
                <option value="New">New</option>
                <option value="Accept">Accept</option>
                <option value="Denied">Denied</option>
              </select>
            </div>

          </div>
        </div>
        <div class="modal-footer">
          <div class="row">
            <div class="col-sm-6"><button type="button" id="btn-modal-update" style="width:200px"
                class="btn btn-success">Save</button></div>
            <div class="col-sm-6"><button type="button" id="btn-modal-cancel" style="width:200px"
                class="btn btn-success">Cancel</button></div>
          </div>
        </div>
      </div>
    </div>
  </div>
  <!---Modal Delete-->
  <div class="modal fade" id="delete-modal">
    <div class="modal-dialog">
      <div class="modal-content">

        <!-- Modal Header -->
        <div class="modal-header">
          <h4 class="modal-title">Confirm Delete</h4>
        </div>

        <!-- Modal body -->
        <div class="modal-body">
          Are you sure Delete?
        </div>

        <!-- Modal footer -->
        <div class="modal-footer">
          <button id="btn-confirm-delete" type="button" class="btn btn-danger">Yes</button>
          <button id="btn-cancel-delete" type="button" class="btn btn-danger">Close</button>
        </div>

      </div>
    </div>


    <script>
      "use strict";
      /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */


      // Biến mảng toàn cục chứa danh sách tên các thuộc tính
      const gUSER_COLS = ["id", "firstname", "lastname", "country", "subject", "customerType", "registerStatus", "action"];

      // Biến mảng toàn cục định nghĩa chỉ số các cột tương ứng
      const gUSER_ID = 0;
      const gUSER_FIRSTNAME = 1;
      const gUSER_LASTNAME = 2;
      const gUSER_COUNTRY = 3;
      const gUSER_SUBJECT = 4;
      const gUSER_CUSTOMER_TYPE = 5;
      const gUSER_REGISTER_STATUS = 6
      const gUSER_ACTION = 7;

      const gBASE_URL = "http://203.171.20.210:8080/crud-api/users/";
      var gUserId = 0;

      var gUserTable = $("#users-table").DataTable({

        columns: [
          { data: gUSER_COLS[gUSER_ID] },
          { data: gUSER_COLS[gUSER_FIRSTNAME] },
          { data: gUSER_COLS[gUSER_LASTNAME] },
          { data: gUSER_COLS[gUSER_COUNTRY] },
          { data: gUSER_COLS[gUSER_SUBJECT] },
          { data: gUSER_COLS[gUSER_CUSTOMER_TYPE] },
          { data: gUSER_COLS[gUSER_REGISTER_STATUS] },
          { data: gUSER_COLS[gUSER_ACTION] }
        ],
        columnDefs: [
          {
            targets: gUSER_ACTION,
            defaultContent: `<button class='btn btn-primary user-update'><i class="fa-solid fa-pen-to-square"></i></button>
        <button class='btn btn-danger user-delete'><i class="fa-solid fa-trash"></i></button>
        `
          }
        ]
      });
      /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
      // gắn sự kiện click cho các nút user detail
      $(document).ready(function () {
        callApiGetAllUsers();

      });
      $("#users-table").on("click", ".user-update", function () {
        onBtnUpdateUserClick(this);
      });
      $("#users-table").on("click", ".user-delete", function () {
        onBtnDeleteUserClick(this);
      });
      $(document).on("click", ".btn-user-add", function () {
        onBtnAddUserClick();
      });
      // tạo sự kiện click nut AddNew
      $("#btn-modal-insert").on("click", function () {
        onBtnInsertClick();
      });
      $("#update-modal").on("click", "#btn-modal-update", function () {
        onBtnSaveClick();
      });
      /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
      function onBtnUpdateUserClick(paramBtnUpdate) {
        gUserId = getUserIdFromBtn(paramBtnUpdate);
        console.log(gUserId);
        $("#update-modal").modal("show");
        loadUserNeedEditToEditModal(paramBtnUpdate);


      }
      function onBtnDeleteUserClick(paramBtnDelete) {
        gUserId = getUserIdFromBtn(paramBtnDelete);
        console.log(gUserId);
        $("#delete-modal").modal("show");
        $("#btn-confirm-delete").on("click", function () {
          $.ajax({
            url: gBASE_URL + gUserId,
            type: "DELETE",
            dataType: "json",
            success: function (res) {
              alert("Delete success");
              $("#delete-modal").modal("hide");
              callApiGetAllUsers();

            },
            error: function (ajaxContext) {
              console.log(ajaxContext.responseText);
            },
          });
        });
        $("#btn-cancel-delete").on("click", function () {
          $("#delete-modal").modal("hide");
        });
      }
      function onBtnAddUserClick() {
        $("#add-new-modal").modal("show");
      }

      function onBtnInsertClick() {
        var vNewUserInfo = {
          firstname: "",
          lastname: "",
          subject: "",
          country: "",
          customerType: ""
        };
        getNewUserData(vNewUserInfo);
        var isOk = validateData(vNewUserInfo);
        if (isOk) {
          $.ajax({
            url: gBASE_URL,
            type: "POST",
            contentType: "application/json; charset-UTF-8",
            data: JSON.stringify(vNewUserInfo),
            success: function (resNewUser) {
              console.log(resNewUser);
              handleNewUserSuccess(resNewUser);

            },
            error: function (ajaxContext) {
              console.log(ajaxContext.responseText);
            },
          });
        }
      }
      function onBtnSaveClick() {
        var vUserNeedEdit = {
          firstname: "",
          lastname: "",
          subject: "",
          country: "",
          customerType: "",
          registerStatus: ""
        }
        getUserNewInfo(vUserNeedEdit);
        console.log(vUserNeedEdit); //xem thu coi ra cái gi hôn
        var vIsCheck = validateDataEidt(vUserNeedEdit);
        if (vIsCheck) {
          $.ajax({
            url: gBASE_URL + gUserId,
            type: "PUT",
            contentType: "application/json; charset-UTF-8",
            data: JSON.stringify(vUserNeedEdit),
            success: function (resEditUser) {
              console.log(resEditUser);
              handleEditUserSuccess(resEditUser);

            },
            error: function (ajaxContext) {
              console.log(ajaxContext.responseText);
            },
          });

        }

        /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
      }
      function callApiGetAllUsers() {
        $.ajax({
          url: gBASE_URL,
          type: "GET",
          dataType: "json",
          success: function (resUsers) {
            console.log(resUsers);
            loadAllUserToTable(resUsers);

          },
          error: function (ajaxContext) {
            console.log(ajaxContext.responseText);
          },
        });
      }

      function loadAllUserToTable(paramResUsers) {
        gUserTable.clear();
        gUserTable.rows.add(paramResUsers);
        gUserTable.draw();

      }
      function getUserIdFromBtn(paramBtn) {
        var vTableRow = $(paramBtn).parents("tr"); //truy xuat row chua btn
        var vUserRowData = gUserTable.row(vTableRow).data();
        console.log(vUserRowData);
        return vUserRowData.id;
      }
      function getNewUserData(paramNewUser) {
        paramNewUser.firstname = $("#inp-firstname").val().trim();
        paramNewUser.lastname = $("#inp-lastname").val().trim();
        paramNewUser.subject = $("#inp-subject").val().trim();
        paramNewUser.country = $("#select-country").val();
        paramNewUser.customerType = $("#select-customer-type").val();

      }

      function validateData(paramNewUser) {
        if (paramNewUser.firstname == "" || paramNewUser.lastname == "" || paramNewUser.subject == "") {
          alert("please fill the form");
          return false;
        }
        return true;
      }
      function handleNewUserSuccess() {
        alert("Success Add a New User...!!!");
        callApiGetAllUsers();
        resetAddNewUserForm();
        $("#add-new-modal").modal("hide");
      }
      function resetAddNewUserForm() {
        $("#inp-firstname").val("");
        $("#inp-lastname").val("");
        $("#inp-subject").val("");
        $("#select-country").val("VN");
        $("#select-customer-type").val("Standard");
      }
      function getUserNewInfo(paramUserNeedEdit) {
        paramUserNeedEdit.firstname = $("#edit-inp-firstname").val().trim();
        paramUserNeedEdit.lastname = $("#edit-inp-lastname").val().trim();
        paramUserNeedEdit.subject = $("#edit-inp-subject").val().trim();
        paramUserNeedEdit.country = $("#edit-select-country").val();
        paramUserNeedEdit.customerType = $("#edit-select-customer-type").val();
        paramUserNeedEdit.registerStatus = $("#edit-select-registerStatus").val();
      }
      function loadUserNeedEditToEditModal(paramBtn) {
        var vTableRow = $(paramBtn).parents("tr"); //truy xuat row chua btn
        var vUserRowData = gUserTable.row(vTableRow).data();
        $("#edit-inp-firstname").val(vUserRowData.firstname);
        $("#edit-inp-lastname").val(vUserRowData.lastname);
        $("#edit-inp-subject").val(vUserRowData.subject);
        $("#edit-select-country").val(vUserRowData.country);
        $("#edit-select-customer-type").val(vUserRowData.customerType);
        $("#edit-select-registerStatus").val(vUserRowData.registerStatus);
      }
      function validateDataEidt(paramUserNeedEdit) {
        if (paramUserNeedEdit.firstname == "" || paramUserNeedEdit.lastname == "" || paramUserNeedEdit.subject == "") {
          alert("Vui Long Nhập đầy đủ");
          return false;
        }
        return true;
      }
      function handleEditUserSuccess(paramEditUser) {
        alert("Edit and Update Success");
        callApiGetAllUsers();
        $("#update-modal").modal("hide");
      }

    </script>
</body>

</html>